/* USER CODE BEGIN Header */
/**
 ******************************************************************************
 * @file           : main.c
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
 * All rights reserved.</center></h2>
 *
 * This software component is licensed by ST under BSD 3-Clause license,
 * the "License"; You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at:
 *                        opensource.org/licenses/BSD-3-Clause
 *
 ******************************************************************************
 */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */



/*
-------------------------------------------------------------------
 ALCiC	Automatyczny Licznik Częstotliwości i Czasu
 AF&TC	Automatic frequency and time counter

-------------------------------------------------------------------
Wejście sygnału:
	A0 (PA0)
	D7 (PA8)

-------------------------------------------------------------------
Połączenia płytki wyświetlacza LED:
	KA-NUCLEO-F411CE		8-bit LED Digital Tube Module (74HC595)
	D11	(PA7-MOSI)			DIO
	D13 (PA5-SCK)			SCLK
	A2 (PA4-NSS)			RCLK

-------------------------------------------------------------------
LCD SSD1306 I2C:
	D9 (PB7-SDA)
	D10 (PB6-SCL)

-------------------------------------------------------------------
 */


//#define	ZERA_PRAWE_OFF					// Wyłączenie nieznaczących zer z prawej strony			todo: dac mozliwośc konfoigurowania w programie
#define	TIM_DEF_GATE	1000			// [ms] dopuszczalne 10ms, 100ms, 1sek 10 sek, 100 sek (todo: 10 i 100 sek nieweryfikowane! Pewnie wymagana zmiana preskalera!)
#define	GRANICA_F		100000			// Granica przełaczania pomiaru z liczenia na obliczenie odwrotności okresu		todo: dac mozliwośc konfoigurowania w programie


/*
todo:

klawisze:
 POMIAR		przełączanie pomiedzy pomiarem czestotliwości, czasu, wypełnienia itd
 HOLD
 REL-
 REL+
 GATE		czas bramkowania 100ms, 1s, 10s, 100s
 000		on/off zera nieznaczące z prawej strony

LED:
 inH
 inL
 HOLD
 REL 		2 kolory, ziel dodawanie, czerwony odejmowanie
 GATE


UART:		ANSI, bufor z kontrola zakresu. Wyświetlaniepomiaru głównego i dodatkowych, czasu GATE i co tam jeszcze trzeba.

USB: opto FT22x (SPI) - moduł robiony dla EdW

LICZNIK:	tryb licznika, wejście przechwytujące-zerujące

EEPROM:		ostatnie nastawy

ADC:		filtr RC i ADC moze mierzyć wypełnienie przetwornikiem ADC.

TFT:		160x128, wymagane min 32kB RAM

WejścieB	dla preskalera

I2C			do sterowania elementami na panelu czołowym

tryb CNT:	osobny licznik 9osobne wejście)


//todo: spróbowac rozpoczać odliczanie po wystąpieniu zbocza sygnału na wejściu licznika. Pewnie i tak nic z tego nie wyjdzie.

 */




/*
---------------- Czas pracy nad programem --------------------
	data		czas	czas	czas		Zadanie
				start	stop	pracy
2020-01-19		11:00 -  1:00	14:00		Pomiar F, t, obsługa LED
2020-01-20		10:00 - 22:00	12:00		obsługa OLED
2020-01-22		23:30 -  2:25	 3:00		wygaszanie zer nieznaczących z prawej strony
2020-01-21		10:00 - 13:30	 3:30		Tryb CNT
2020-01-21		15:00 - 18:30	 3:00		Poprawki formatowania stringówT
2020-01-23		 9:00 - 10:30	 1:50		Modernizacja MENU led, ANSII na UART
2020-01-25		20:00 -  1:30	 5:30		Sprzętowe GATE
						SUMA	42:30 * 100zł/h =  4200zł
2020-01-25		11:00 - 14:30	 3:30		Precyzyjny pomiar długich czasów, testy na NUCLEO-L412-RB-P
2020-01-25						 2:00		Długie czasy/okres z dużą rozdzielczością (tim1 + tim2) na NUCLEO-L412-RB-P

 */


#include <stdio.h>
#include <string.h>


#include "../lcd/ssd1306_i2c_spi.h"
#include "../lcd/graph.h"


#define	STOPKA1		"AVT-9999"


/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

#define	TRAP				__NOP()


#define	F_CPU			100000000		// 100MHz
//todo: dodatkowy licznik bramkowany (nieprecyzyjne) 1Hz do przełaczania pomiedzy bramkowaniem 1s (2s) a 100ms (200ms)
//todo: może zliczanie przejść zboczy (już jest) aby oszacowac jaki sygnał jest na wejściu?



#define	LICZBA_LED		8
uint8_t bufLED[ LICZBA_LED ] = {1,1,1,6,16,32,64,128};


/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
I2C_HandleTypeDef hi2c1;
DMA_HandleTypeDef hdma_i2c1_tx;

IWDG_HandleTypeDef hiwdg;

SPI_HandleTypeDef hspi1;
DMA_HandleTypeDef hdma_spi1_tx;

TIM_HandleTypeDef htim1;
TIM_HandleTypeDef htim2;
TIM_HandleTypeDef htim3;

UART_HandleTypeDef huart2;
DMA_HandleTypeDef hdma_usart2_tx;

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_SPI1_Init(void);
static void MX_TIM1_Init(void);
static void MX_TIM2_Init(void);
static void MX_IWDG_Init(void);
static void MX_TIM3_Init(void);
static void MX_DMA_Init(void);
static void MX_USART2_UART_Init(void);
static void MX_I2C1_Init(void);
/* USER CODE BEGIN PFP */


/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */


uint16_t volatile timPrintLed, timInput, timUart, timLedRun, timSendUsb, timMax7219 = 5000, timDemo = 5000;
uint8_t volatile KeyUSER;
uint16_t volatile cntChangeInput;
//-------------------------------------------------------------------
void irq1ms(){

	//----- Timery -----//
	if( timPrintLed ) timPrintLed--;
	if( timInput ) timInput--;
	if( timUart ) timUart--;
	if( timLedRun ) timLedRun--;
	if( timDemo ) timDemo--;
	if( timMax7219 ) timMax7219--;
	if( timSendUsb ) timSendUsb--;


	//----- Klawisze -----//
	int8_t static cntPB;
	if( HAL_GPIO_ReadPin( PB_USER_GPIO_Port, PB_USER_Pin) ){
		if( cntPB < 10 ) cntPB++; else KeyUSER = 0;
	}
	else{
		if( cntPB > -10 ) cntPB--; else KeyUSER = 1;
	}



	//----- Oszacowanie częstotliwości zmian sygnału na wejściu
	uint16_t static cntChgIn, divChg = 1000;
	uint8_t static prevGpio;
	if( prevGpio != HAL_GPIO_ReadPin( GPIOA, GPIO_PIN_8 ) ){
		prevGpio = HAL_GPIO_ReadPin( GPIOA, GPIO_PIN_8);
		cntChgIn++;
	}
	if( --divChg == 0 ){
		divChg = 1000;

		cntChangeInput = cntChgIn;
		cntChgIn = 0;
	}



}


//-------------------------------------------------------------------
void LedInit(){
	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_RESET );

	SPI1->CR1 |= SPI_CR1_SPE;		// Włączenie SPI (skonfigurowane jest przez HAL)
	//	SPI1->CR2 |= SPI_CR2_TXEIE;		// IRQ gdy bufor nadawczy pusty
}


//-------------------------------------------------------------------
void irqSpi1(){
	/*
	// SPI in mode Transmitter -------------------------------------------------
	if ( (SPI_CHECK_FLAG( SPI1->SR, SPI_FLAG_TXE) != RESET) )
	{
		HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_RESET );	// Zbocze narastające zatrzaskuje dane
		HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_SET );

	}
	 */
}


//-------------------------------------------------------------------
void irqTim1update(void){
	__NOP();
	//todo: przepelnienie wiec pomiar bledny, trzeba zmienic preskaler
}


//-------------------------------------------------------------------
uint8_t mnoznikF;
uint32_t volatile T1PulsL, T1PulsH, T1Okres;
uint32_t timGate;
//-------------------------------------------------------------------
void setGate( uint32_t gate ){


	//----- Weryfikacja poprawności parametru
	if( gate != 10 &&
			gate != 100 &&
			gate != 1000 &&
			gate != 10000 &&
			gate != 10000){ 			// Jak zła to domyslne bramkowanie 1 sekunda
		gate = 1000;
	}

	//todo: 10 i 100 sek nieweryfikowane!
	//todo: 100 sek wymaga zmiany preskalera!
	timGate = gate;
	TIM3->ARR = gate * 2 + 50;		// sekunda (100ms, 10ms, 10sek) + 50
	TIM3->CCR1 = gate * 2;		// sekunda (100ms, 10ms, 10sek)

	if( gate == 1000 ) mnoznikF = 1;
	else if( gate == 100 ) mnoznikF = 10;
	else if( gate == 10 ) mnoznikF = 100;
	//todo: else
}


//-------------------------------------------------------------------
uint32_t volatile tim2_H;
uint32_t volatile cntlatch;
//-------------------------------------------------------------------
void irqTim2update(){
	TRAP;

	tim2_H++;
	// nie trzeba bo T2 ma 32 bity
}


//-------------------------------------------------------------------
uint16_t volatile mnoznikT;
uint32_t volatile T2freq;
uint32_t volatile Freq;
//-------------------------------------------------------------------
void irqTim3update(){
	uint64_t static prevCnt64;


	uint32_t CntL = TIM2->CNT;
	uint64_t Cnt64 = (uint64_t)(tim2_H * 2^32) + CntL;

	T2freq = Cnt64 - prevCnt64;
	prevCnt64 = Cnt64;


	//T2freq = TIM2->CNT;
	//TIM2->CNT = 0;
	TRAP;
	T2freq *= mnoznikF;
	//Freq = T2freq;


	T1PulsL = TIM1->CCR2;
	T1Okres = TIM1->CCR1;


	//	HAL_GPIO_TogglePin(GATE_OUT_GPIO_Port, GATE_OUT_Pin);
	TRAP;
}


//-------------------------------------------------------------------
uint32_t volatile tim2_gate_H, tim2_gate_L;
//-------------------------------------------------------------------
void irqTim2trigger(void){
	TRAP;

	if( HAL_GPIO_ReadPin( GPIOA, GPIO_PIN_1 )){		// wejście IT2FP2
		HAL_GPIO_WritePin( GATE_OUT_GPIO_Port, GATE_OUT_Pin, GPIO_PIN_SET );
		tim2_gate_L = TIM2->CNT;	// ile impulsow by przepadło gdyby robic to programowo
		TRAP;
	}
	else{
		HAL_GPIO_WritePin( GATE_OUT_GPIO_Port, GATE_OUT_Pin, GPIO_PIN_RESET );
		tim2_gate_H = TIM2->CNT;
		Freq = tim2_gate_H * mnoznikF;

		TIM2->CNT = 0;
		TRAP;
	}
}


//-------------------------------------------------------------------
uint8_t ConvChar2led( char znak )
{
	switch( znak )
	{
	case 0:		znak = 0; break;
	case '-':	znak = 0b1000000; break;
	case '_':	znak = 0b0001000; break;		// Użyte w komunikacie "_Tes_T
	case '|':	znak = 0b0110000; break;		// Użyte w PrintOverflow

	case '0':	znak = 0b0111111; break;
	case '1':	znak = 0b0000110; break;
	case '2':	znak = 0b1011011; break;
	case '3':	znak = 0b1001111; break;
	case '4':	znak = 0b1100110; break;
	case '5':	znak = 0b1101101; break;
	case '6':	znak = 0b1111101; break;
	case '7':	znak = 0b0000111; break;
	case '8':	znak = 0b1111111; break;
	case '9':	znak = 0b1101111; break;

	case ' ':	znak = 0; break;
	case 'A':	znak = 0b1110111; break;
	case 'a':	znak = 0b1110111; break;
	case 'B':	znak = 0b1111100; break;
	case 'b':	znak = 0b1111100; break;
	case 'C':	znak = 0b0111001; break;
	case 'c':	znak = 0b1011000; break;
	case 'D':	znak = 0b1011110; break;
	case 'd':	znak = 0b1011110; break;
	case 'E':	znak = 0b1111001; break;
	case 'e':	znak = 0b1111001; break;
	case 'F':	znak = 0b1110001; break;
	case 'f':	znak = 0b1110001; break;
	case 'i':	znak = 0b0010000; break;
	case 'I':	znak = 0b0110000; break;
	case 'R':	znak = 0b1010000; break;
	case 'r':	znak = 0b1010000; break;
	case 'V':	znak = 0b0111110; break;
	case 'v':	znak = 0b0011100; break;
	case 'U':	znak = 0b0111110; break;
	case 'u':	znak = 0b0011100; break;
	case 'T':	znak = 0b0110001; break;
	case 't':	znak = 0b0110001; break;
	case 'N':	znak = 0b0110111; break;
	case 'n':	znak = 0b1010100; break;
	case 'o':	znak = 0b1011100; break;
	case 'O':	znak = 0b0111111; break;
	case 's':	znak = 0b1101101; break;
	case 'S':	znak = 0b1101101; break;
	case 'L':	znak = 0b0111000; break;
	case 'H':	znak = 0b1110110; break;
	case 'l':	znak = 0b0111000; break;
	case 'Y':	znak = 0b1101110; break;
	case 'y':	znak = 0b1101110; break;
	//   gfedcba
	default: znak=0;
	}


	return( znak );
}


//----------------------------------------------------------------------//
void PrintDOT( uint8_t dot  ){
	if( dot < 8 ) bufLED[ dot ] |= 128;
}


//-------------------------------------------------------------------
void ClrLED() {
	for(uint8_t x=0; x<LICZBA_LED; x++) bufLED[x] = 0;
}


//----------------------------------------------------------------------//
void PrintStringLED( char *str ) {
	ClrLED();
	for(int8_t x=LICZBA_LED-1; x!=-1; x--){
		if( ! *str ) break;
		bufLED[x] = ConvChar2led( *str++ );
	}
}


//----------------------------------------------------------------------//
void PrintStringDotLED( char *str, uint8_t dot ) {
	ClrLED();
	//----- Konwersja takstu na kody LED 7-seg
	for(int8_t x=LICZBA_LED-1; x!=-1; x--){
		if( ! *str ) break;
		bufLED[x] = ConvChar2led( *str++ );
		if( dot & (1<<x) ) bufLED[ x ] |= 128;
	}
}


//----------------------------------------------------------------------//
int8_t convStrDot( char *txt ){
	char tm[20];
	strncpy( tm, txt, 19 );


#ifndef ZERA_PRAWE_OFF
	//	strcpy( tm, "123456789abc" );


	//----- Skrócenie teksu to 8 lub 9 znaków zależnie czy jest w nik kropka czy nie -----//
	uint8_t spearator = false;
	for(uint8_t k=0; k<strlen(tm); k++){	// Szukanie kropki
		if( tm[k] == '.' ){
			tm[LICZBA_LED+1] = 0;
			spearator = true;
			break;
		}
	}
	if( ! spearator ) tm[LICZBA_LED] = 0;


	//----- Zastępienie "0" z prawej strony znakiem spacji o ile poprzedni znak nie jest kropką
	int8_t w;
	for(w=strlen( tm )-1; w!=-1; w--){
		if( tm[w] == '0' && tm[w-1] != '.' ) tm[w] = ' '; else break;
	}
	w = strlen( tm )-1 - w;
	TRAP;
	//----- Przesunięcie do prawej
	for(int8_t y=0; y<w; y++){
		for(int8_t x=strlen( tm )-1; x>0; x--){
			tm[x] = tm[x-1];
			if( x ) tm[x-1] = ' ';
		}
	}
	TRAP;
#endif


	//----- Zlikwidowanie znaku kropki, ustawienie bitów "dot" na pozycjach, na których były kropki
	uint8_t d=0;
	uint8_t dot=0;
	for(uint8_t s=0; s<strlen(tm); s++) {
		if( tm[s] == '.' ){
			dot |= (1<< (LICZBA_LED-s) );
			TRAP;
		}
		else{
			txt[d++] = tm[s];
		}
	}
	txt[d] = 0;
	TRAP;


	return dot;
}


//----------------------------------------------------------------------//
uint8_t  PrintJednostki_TFT( char * txt ){
	ssd1306_SetFont( 0x1632 );
	return ssd1306_PrintString( 0, 0, txt, 1 );
}


//----------------------------------------------------------------------//
void PrintFreqTFT( uint8_t x, uint8_t y, uint32_t freq, float fx ){
	char txt[30];


	//----- Drugi wskaźnik
	if( freq >= GRANICA_F ){
		if( freq > 1000000  ){
			sprintf( txt, "%d.%06d MHz", (int)freq / 1000000, (int)freq % 1000000 );
		}
		else if( freq > 1000  ) sprintf( txt, "%d.%03d kHz", (int)(freq / 1000), (int)(freq % 1000) );
		else sprintf( txt, "%d Hz", (int)freq );
	}
	else{
		if( fx >= 1000000.0 ) sprintf( txt, "%0.6f MHz", fx / 1000000.0 );
		else if( fx >= 1000.0 )sprintf( txt, "%0.6f kHz", fx / 1000.0 );
		else sprintf( txt, "%0.3f Hz", fx );
	}
	ssd1306_SetFont( 0x0705 );	//todo: 12x8
	ssd1306_PrintString( x, y, txt, 1 );
}


//----------------------------------------------------------------------//
uint8_t PrintTimeTFT( const char *txt, uint8_t x, uint8_t y, float wartosc ){
	char buf[30];


	uint8_t pozX = (int8_t)ssd1306_PrintString( x, y, (char*)txt, 1 );

	if( wartosc >= 1000000.0 ) sprintf( buf, "%0.6f s", wartosc / 1000000.0 );
	else if( wartosc >= 1000.0 ) sprintf( buf, "%0.6f ms", wartosc / 1000.0 );
	else if ( wartosc >= 1.0 ) sprintf( buf, "%0.3f us", wartosc );
	else sprintf( buf, "%0.0f ns", wartosc * 1000.0 );


	return ssd1306_PrintString( pozX, y, buf, 1 );
}


//----------------------------------------------------------------------//
uint8_t PrintFreqIntLED( uint32_t f, const char *cmt ){
	char txt[30];
	uint8_t dot = 0 ;
	uint8_t pozX = 0;


	if( f >= 1000000 ){
		sprintf( txt, "% 2d.%06d", (int)(f/1000000), (int)(f % 1000000) );
		dot = convStrDot( txt );
		PrintStringDotLED( txt, dot );
		pozX = PrintJednostki_TFT( "MHz" );
		pozX = ssd1306_PrintString( pozX+8, 0, (char*)cmt, 1 );
	}
	else if( f >= 1000 ){
		sprintf( txt, "% 5d.%03d", (int)(f/1000), (int)(f % 1000) );
		dot = convStrDot( txt );
		PrintStringDotLED( txt, dot );
		pozX = PrintJednostki_TFT( "kHz" );
		pozX = ssd1306_PrintString( pozX+8, 0, (char*)cmt, 1 );
		TRAP;
	}
	else{
		sprintf( txt, "% 8d", (int)f );
		PrintStringDotLED( txt, 1 );
		pozX = PrintJednostki_TFT( "Hz" );
		pozX = ssd1306_PrintString( pozX+8, 0, (char*)cmt, 1 );
	}


	return pozX;
}


//----------------------------------------------------------------------//
uint8_t PrintCntIntLED( uint32_t cnt, const char *cmt ){
	char txt[30];
	uint8_t dot = 0;
	uint8_t pozX = 0;


	sprintf( txt, "%8d", (int)cnt );
	if ( cnt >= 1000 ) dot |= 1<<3;
	if ( cnt >= 1000000 ) dot |= 1<<6;
	PrintStringDotLED( txt, dot );
	pozX = PrintJednostki_TFT( "imp" );
	pozX = ssd1306_PrintString( pozX+8, 0, (char*)cmt, 1 );


	return pozX;
}


//----------------------------------------------------------------------//
uint8_t PrintFreqFloatLED( float f, const char *cmt ){
	char txt[30];
	uint8_t dot = 0;
	uint8_t pozX = 0;


	if( f == 0.0 ){
		PrintStringDotLED( "       0", 1 );
		pozX = PrintJednostki_TFT( "Hz" );
		pozX = ssd1306_PrintString( pozX+8, 0, (char*)cmt, 1 );
		TRAP;
	}
	else if( f >= 1000000.0 ){
		sprintf( txt, "%8.6f", f / 1000000.0 );
		dot = convStrDot( txt );
		PrintStringDotLED( txt, dot );
		pozX = PrintJednostki_TFT( "MHz" );
		pozX = ssd1306_PrintString( pozX+8, 0, (char*)cmt, 1 );
		TRAP;
	}
	else if( f >= 1000.0 ){
		sprintf( txt, "%8.6f", f / 1000.0 );
		dot = convStrDot( txt );
		PrintStringDotLED( txt, dot );
		pozX = PrintJednostki_TFT( "kHz" );
		pozX = ssd1306_PrintString( pozX+8, 0, (char*)cmt, 1 );
		TRAP;
	}
	else{
		sprintf( txt, "%8.6f", f );
		dot = convStrDot( txt );
		PrintStringDotLED( txt, dot );
		pozX = PrintJednostki_TFT( "Hz" );
		pozX = ssd1306_PrintString( pozX+8, 0, (char*)cmt, 1 );
		TRAP;
	}


	return pozX;
}


//----------------------------------------------------------------------//
uint8_t PrintTimeFloatLED( float wartoscs, const char *cmt ){
	char txt[30];
	uint8_t dot = 0;
	uint8_t pozX = 0;


	if( wartoscs >= 1000000.0 ) {
		sprintf( txt, "%8.7f", wartoscs/1000000 );	// Ponad sekunda
		pozX = PrintJednostki_TFT( "s" );
	}
	else if( wartoscs >= 100000.0 ){
		sprintf( txt, "%8.5f", wartoscs/1000 );	// Ponad 100ms
		pozX = PrintJednostki_TFT( "ms" );
	}
	else if( wartoscs >= 10000.0 ){
		sprintf( txt, "%8.5f", wartoscs/1000 );	// Ponad 10ms
		pozX = PrintJednostki_TFT( "ms" );
	}
	else if( wartoscs >= 1000.0 ){
		sprintf( txt, "%8.4f", wartoscs/1000 );		// Ponad 1ms
		pozX = PrintJednostki_TFT( "ms" );
	}
	else if( wartoscs >= 10.0 ){
		sprintf( txt, "%8.3f", wartoscs );			// Ponad 100us
		pozX = PrintJednostki_TFT( "us" );
	}
	else if( wartoscs >= 1.0 ){
		sprintf( txt, "%8.2f", wartoscs );				// Ponad 1us
		pozX = PrintJednostki_TFT( "us" );
	}
	else {
		sprintf( txt, "%8.1f", wartoscs );				// Ponad 100ns
		pozX = PrintJednostki_TFT( "us" );
	}
	dot = convStrDot( txt );
	PrintStringDotLED( txt, dot );
	pozX = ssd1306_PrintString( pozX+10, 0, (char*)cmt, 1 );


	return pozX;
}


//----------------------------------------------------------------------//
void PrintGateTFT( uint8_t x, uint8_t y ){
	char txt[30];

	if( timGate >= 1000 ) sprintf( txt, "Gate %d s", (int)(timGate / 1000) );
	else sprintf( txt, "Gate %d ms", (int)timGate );

	ssd1306_PrintString( x, y, txt, 1 );
}


//----------------------------------------------------------------------//
void ReadSetFtime(){
	const float f_min = 1500; // przy 1`525 (100MHz/2^16) przepełnienie  (F_CPU / 2^16) * 0.98;
	/*
			if ( Freq > f_min ) { // przy 1`525 (100MHz/2^16) przepełnienie
				mnoznikT = 1;
				T1PulsH = TIM1->CCR2;
				T1Okres = TIM1->CCR1;
			}
			else if ( Freq > f_min / 10 ) {
				mnoznikT = 10;
				T1PulsH = TIM1->CCR2 * mnoznikT;
				T1Okres = TIM1->CCR1 * mnoznikT;
			}
			else if ( Freq > f_min / 100 ) {
				mnoznikT = 100;
				T1PulsH = TIM1->CCR2 * mnoznikT;
				T1Okres = TIM1->CCR1 * mnoznikT;
			}
			else {
				mnoznikT = 10000;
				T1PulsH = TIM1->CCR2 * mnoznikT;
				T1Okres = TIM1->CCR1 * mnoznikT;
			}
	 */
	for(uint8_t p=1; p<102; p++){
		if ( Freq > f_min / p ) { // przy 1`525 (100MHz/2^16) przepełnienie
			mnoznikT = p;
			T1PulsH = TIM1->CCR2 * mnoznikT;
			T1Okres = TIM1->CCR1 * mnoznikT;
			TRAP;
			break;
		}
		if( p == 101 ){
			mnoznikT = 10000;
			T1PulsH = TIM1->CCR2 * mnoznikT;
			T1Okres = TIM1->CCR1 * mnoznikT;
		}
	}

	TIM1->PSC = mnoznikT-1;
	//todo: mnoznikT-1; i reszte operacji z mnoznikT zweryfikowac i poprawic w sondzie graficznej. Nowy soft na serwer

	TRAP;
}


//======================================================================//
/*
---------------- Czas pracy nad oprogramowaniem MAX7219 --------------------
	data		czas	czas	czas		Zadanie
				start	stop	pracy
2020-01-02 		??:??	13:00	10:00

 */


//----------------------------------------------------------------------//
#define	LICZBA_MAX7219		12
//----------------------------------------------------------------------//
void MAX7219_send( uint16_t data ){
	SPI1->DR = data;                      // wpisz dana do rejestru nadawczego
	while( SPI1->SR & SPI_FLAG_BSY ) __NOP();
	for(uint32_t x=0; x<1000; x++ ) __NOP();

	//uint8_t d[2];
	//d[0] = data >> 8;
	//d[1] = data;
	//HAL_SPI_Transmit( &hspi1, d, 2, 1 );
}


//----------------------------------------------------------------------//
void MAX7219_intensity( uint8_t d ){
	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_RESET );
	for(uint8_t x=0; x<LICZBA_MAX7219; x++) MAX7219_send( 0xA00 + d );	// Intensity
	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_SET );
}


//----------------------------------------------------------------------//
void MAX7219_init( uint8_t Intensity ){
	// SPI w trybie 16-bit!
	// Reszta standard, MSB pierwszy, MODE 0.

	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_SET );

	SPI1->CR1 |= SPI_CR1_SPE;		// Włączenie SPI (skonfigurowane jest przez HAL)
	//	SPI1->CR2 |= SPI_CR2_TXEIE;		// IRQ gdy bufor nadawczy pusty


	// INFO: Ważna kolejność zapisu rejestrów
	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_RESET );
	for(uint8_t x=0; x<LICZBA_MAX7219; x++) MAX7219_send( 0xF00 );	// Test
	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_SET );

	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_RESET );
	for(uint8_t x=0; x<LICZBA_MAX7219; x++) MAX7219_send( 0xB07 );	// Scan Limit (musi byc pierwsze
	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_SET );

	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_RESET );
	for(uint8_t x=0; x<LICZBA_MAX7219; x++) MAX7219_send( 0xA00 + Intensity );	// Intensity
	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_SET );

	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_RESET );
	for(uint8_t x=0; x<LICZBA_MAX7219; x++) MAX7219_send( 0x900 );	// Decode Mode
	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_SET );

	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_RESET );
	for(uint8_t x=0; x<LICZBA_MAX7219; x++) MAX7219_send( 0xC01 );	// Shutdown
	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_SET );
}


//----------------------------------------------------------------------//
void MAX7219_send_1( uint16_t data ){
	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_RESET );
	MAX7219_send( data );
	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_SET );
}


//----------------------------------------------------------------------//
void MAX7219_send_X( uint16_t *data, uint8_t c ){
	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_RESET );

	for(uint8_t x=0; x<c; x++){
		MAX7219_send( *data++ );
		while( SPI1->SR & SPI_FLAG_BSY ) __NOP();
		for(uint32_t x=0; x<1000; x++ ) __NOP();
	}

	HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_SET );
}


//----------------------------------------------------------------------//
#define	MAX7219_SZER	(LICZBA_MAX7219*8)		// Rozdzielczość pozioma
#define	MAX7219_WYS		8						// Pionowa
uint8_t scrMAX7219[ LICZBA_MAX7219 ][8];
//----------------------------------------------------------------------//
void MAX7219_send_scr(){
	for(uint8_t x=0; x<8; x++){
		HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_RESET );
		uint16_t cmd = x+1;
		cmd <<= 8;
		for(uint8_t w=0; w<LICZBA_MAX7219; w++){
			uint8_t data = scrMAX7219[ w ][ x ];
			MAX7219_send( cmd | data );
			while( SPI1->SR & SPI_FLAG_BSY ) __NOP();
			for(uint32_t x=0; x<1000; x++ ) __NOP();
		}
		HAL_GPIO_WritePin( LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_SET );
	}
}


//----------------------------------------------------------------------//
void MAX7219_Clr(){
	for(uint8_t x=0; x<LICZBA_MAX7219; x++){
		for(uint8_t y=0; y<8; y++){
			scrMAX7219[ x ][ y ] = 0;
		}
	}
}


//----------------------------------------------------------------------//
void MAX7219_PixelSet( int16_t x, int16_t y ){
	if( x < 0 || x >= MAX7219_SZER ) return;
	if( y < 0 || y >= MAX7219_WYS ) return;

	uint8_t w = x >> 3;		// nr wyswietlacza
	uint8_t p = x & 7;		// nr piksela na matrycy 8x8
	p = 7 - p;
	p = 1 << p;
	scrMAX7219[ w ][ y ] |=  p;
}


//----------------------------------------------------------------------//
void MAX7219_PixelClr( int16_t x, int16_t y ){
	if( x < 0 || x >= MAX7219_SZER ) return;
	if( y < 0 || y >= MAX7219_WYS ) return;

	uint8_t w = x >> 3;		// nr wyswietlacza
	uint8_t p = x & 7;		// nr piksela na matrycy 8x8
	p = 7 - p;
	p = 1 << p;
	scrMAX7219[ w ][ y ] &=  ~p;
}


//------------------------------------------------------------------//
void MAX7219_drawPixel( int16_t x, int16_t y, int16_t color ){
	if( color )MAX7219_PixelSet( x, y);
	else MAX7219_PixelClr( x, y );
}


//------------------------------------------------------------------//
uint16_t font_MAX7219 = 0x0507;
extern const unsigned char Font5x7[];
extern const unsigned char lenFont5x7[];
extern const unsigned char Font16x16[];
extern const unsigned char Font16x32[];
extern unsigned char LenFontSpc;
//------------------------------------------------------------------//
//		Rysuje znak nieproporcjonalny na LCD
//		Zwraca next wolna pozycje x
//------------------------------------------------------------------//
int16_t MAX7219_DrawFont(int16_t x, int16_t y, char znak, uint8_t color ){
	uint16_t AdrGenChar;
	uint8_t len;


	//znak=LcdWin2Lcd(znak);
	AdrGenChar = znak << 3;			// Adres wzoru znaku w generatorze


	if ( font_MAX7219 == 0x1632 )
	{
		len = 16;//todo:

		//  znak = LcdWin2Lcd(znak);
		AdrGenChar = znak << 6;   // Adres wzoru znaku w generatorze (64 bajty na znak)
		for (uint8_t yy = 0; yy < 32; yy++)
		{
			uint16_t cc = Font16x32[ AdrGenChar + (yy << 1)] << 8 | Font16x32[ AdrGenChar + 1 + (yy << 1) ];
			for (uint8_t xx = 0; xx < len; xx++)
				if ( cc & (1 << (len - 1 - xx)) ) {	MAX7219_drawPixel( x+xx-1, yy+y, color ); }
				else { MAX7219_drawPixel( x+xx-1, yy+y, color^1 ); }
		}
	}
	else if ( font_MAX7219 == 0x1616 )
	{
		len = 16;//todo:

		//  znak = LcdWin2Lcd(znak);
		AdrGenChar = (znak - 32) << 5;   // Adres wzoru znaku w generatorze (32 bajty na znak)
		for (uint8_t yy = 0; yy < 16; yy++)
		{
			uint16_t cc = Font16x16[ AdrGenChar + (yy << 1)] << 8 | Font16x16[ AdrGenChar + 1 + (yy << 1) ];
			for (uint8_t xx = 0; xx < len; xx++)
				if ( cc & (1 << (len - 1 - xx)) ) {	MAX7219_drawPixel( x+xx-1, yy+y, color ); }
				else { MAX7219_drawPixel( x+xx-1, yy+y, color^1 ); }
		}
	}
	else  //----- Domyslny font 5x7 proporcjonalny
	{
		if( znak==' ' ) len = LenFontSpc;
		else len = lenFont5x7[ znak ] + 1;
		//len=8;

		for(byte yy=0; yy<8; yy++)
		{
			byte c= Font5x7[ AdrGenChar+yy ];
			uint8_t mask = len-2;
			for(uint8_t xx=0; xx<len; xx++){
				if( c & (1 << mask) ) MAX7219_drawPixel( x+xx, y+yy, color );
				else MAX7219_drawPixel( x+xx, y+yy, color^1 );
				mask--;
			}
		}
		//		len++;
	}


	return( x+len );
}


//-----------------------------------------------------------------
int16_t MAX72196_PrintString(int16_t x, int16_t y, char *text, uint8_t color){
	char znak;

	while (*text)					// Wyswietl tekst z RAMu
	{
		znak = (*text);
		x=MAX7219_DrawFont(x, y, znak, color);
		text++;
	}


	return( x );
}


//======================================================================//
uint8_t addressFT201 = 0x44;
uint8_t broadcastI2Cadr = 0;
uint8_t idFT201[3];
uint8_t FT201status;
//0x00 Suspended
//0x01 Default
//0x02 Addressed
//0x03 Configured
uint8_t static mtpFT201[256];
//----------------------------------------------------------------------//
void ReanimacjaI2C()
{
	// Funkcję wstawic w:
	//	/* USER CODE BEGIN SysInit */
	//
	//	MX_GPIO_Init();
	//	ReanimacjaI2C();
	//
	//	/* USER CODE END SysInit */
	//
#define PORT_I2C    GPIOB
#define PIN_SCL     GPIO_PIN_6
#define PIN_SDA     GPIO_PIN_7


	HAL_I2C_DeInit(&hi2c1);


	HAL_GPIO_WritePin( GPIOB, PIN_SDA, GPIO_PIN_SET );  // SDA=H
	HAL_GPIO_WritePin( GPIOB, PIN_SCL, GPIO_PIN_SET );  // SCL=H
	HAL_Delay(1);

	//Configure GPIO Output pins : PB6 - SCL, PB7 - SDA
	GPIO_InitTypeDef GPIO_InitStruct;
	GPIO_InitStruct.Pin = PIN_SCL | PIN_SDA;
	GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
	GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
	HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

	HAL_GPIO_WritePin( GPIOB, PIN_SDA, GPIO_PIN_RESET );  // SDA=L
	HAL_Delay(1);
	HAL_GPIO_WritePin( GPIOB, PIN_SCL, GPIO_PIN_RESET );  // SCL=L
	for (u8 x = 0; x < 9; x++) {
		HAL_Delay(1);
		HAL_GPIO_WritePin( GPIOB, PIN_SCL, GPIO_PIN_SET );  // SCL=H
		HAL_Delay(1);
		HAL_GPIO_WritePin( GPIOB, PIN_SCL, GPIO_PIN_RESET );  // SCL=L
	}
	//----- Stop IIC -----//
	HAL_Delay(1);
	HAL_GPIO_WritePin( GPIOB, PIN_SCL, GPIO_PIN_SET );  // SCL=H
	HAL_Delay(1);
	HAL_GPIO_WritePin( GPIOB, PIN_SDA, GPIO_PIN_SET );  // SDA=H


	MX_I2C1_Init();
	/*
    //Configure GPIO alternate functions pins : PB6 - SCL, PB7 - SDA
    GPIO_InitStruct.Pin = PIN_SCL | PIN_SDA;
    GPIO_InitStruct.Mode = GPIO_MODE_AF_OD;
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
    HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);
	 */


	//eeprom.reanimacjaI2C++;
	//sprintf( str_buf, ANSI_PEN_RED"Reanimacja I2C %d"CRLF, (int)eeprom.reanimacjaI2C ); SendStringTerminal( str_buf );
}


//----------------------------------------------------------------------//
uint8_t ReadcmdFT201( uint8_t cmd ){
	uint32_t volatile dummy;
	uint8_t odczyt;
	UNUSED( dummy );

	__NOP();
	__HAL_I2C_ENABLE( &hi2c1 );	// I2C1->CR1 |= I2C_CR1_PE;		//  LL_I2C_Enable(I2C1);

	I2C1->CR1 |= I2C_CR1_START;      		//   I2C1_CR1_START_bb = 1;               // request a start
	while ( (I2C1->SR1 & I2C_SR1_SB) == 0 ); // while ( I2C1_SR1_SB_bb == 0);         // wait for start to finish
	dummy = I2C1->SR1;                  		// read of SR1 clears the flag
	//
	I2C1->DR = broadcastI2Cadr;						// transfer address
	while ( (I2C1->SR1 & I2C_SR1_ADDR) == 0);			// wait for address transfer
	dummy = I2C1->SR1;						// clear the flag
	dummy = I2C1->SR2;
	//
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0);		// wait for DR empty
	I2C1->DR = cmd;					// trasnsfer byte
	//
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0 || (I2C1->SR1 & I2C_SR1_BTF) == 1 );	// wait for bus not-busy
	//		I2C1->CR1 |= I2C_CR1_STOP;					// wygeneruj a stop
	//	   	while(I2C1->CR1 & I2C_CR1_STOP);			// czekaj na stop


	I2C1->CR1 |= I2C_CR1_START;      		//   I2C1_CR1_START_bb = 1;               // request a start
	while ( (I2C1->SR1 & I2C_SR1_SB) == 0 ); // while ( I2C1_SR1_SB_bb == 0);         // wait for start to finish
	dummy = I2C1->SR1;                  		// read of SR1 clears the flag
	//
	I2C1->DR = addressFT201 | 1;						// transfer address
	while ( (I2C1->SR1 & I2C_SR1_ADDR) == 0);			// wait for address transfer
	dummy = I2C1->SR1;						// clear the flag
	dummy = I2C1->SR2;
	//
	I2C1->CR1 &= ~I2C_CR1_ACK;					// NACK - ostatni (w tym przypadku jedyny) bajt do odczytu
	while ( (I2C1->SR1 & I2C_SR1_RXNE) == 0 );
	odczyt = I2C1->DR;
	//
	I2C1->CR1 |= I2C_CR1_STOP;					// wygeneruj stop
	while(I2C1->CR1 & I2C_CR1_STOP);			// czekaj na stop

	__NOP();
	return odczyt;
}


//------------------------------------------------------------
void ReadIdFT201(){
	uint8_t adr = 0xF8;
	uint32_t volatile dummy;
	UNUSED( dummy );

	idFT201[ 0 ] = idFT201[ 1 ] = idFT201[ 2 ] = 255;

	__NOP();
	__HAL_I2C_ENABLE( &hi2c1 );	// I2C1->CR1 |= I2C_CR1_PE;		//  LL_I2C_Enable(I2C1);

	I2C1->CR1 |= I2C_CR1_START;      		//   I2C1_CR1_START_bb = 1;               // request a start
	while ( (I2C1->SR1 & I2C_SR1_SB) == 0 ); // while ( I2C1_SR1_SB_bb == 0);         // wait for start to finish
	dummy = I2C1->SR1;                  		// read of SR1 clears the flag
	//
	I2C1->DR = adr;						// transfer address
	while ( (I2C1->SR1 & I2C_SR1_ADDR) == 0);			// wait for address transfer
	dummy = I2C1->SR1;						// clear the flag
	dummy = I2C1->SR2;
	//
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0);		// wait for DR empty
	I2C1->DR = addressFT201 | 1;					// trsnsfer byte
	//
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0 || (I2C1->SR1 & I2C_SR1_BTF) == 1 );	// wait for bus not-busy
	//		I2C1->CR1 |= I2C_CR1_STOP;					// wygeneruj stop
	//	   	while(I2C1->CR1 & I2C_CR1_STOP);			// czekaj na stop


	I2C1->CR1 |= I2C_CR1_START;      		//   I2C1_CR1_START_bb = 1;               // request a start
	while ( (I2C1->SR1 & I2C_SR1_SB) == 0 ); // while ( I2C1_SR1_SB_bb == 0);         // wait for start to finish
	dummy = I2C1->SR1;                  		// read of SR1 clears the flag
	//
	I2C1->DR = adr | 1;						// transfer address
	while ( (I2C1->SR1 & I2C_SR1_ADDR) == 0);			// wait for address transfer
	dummy = I2C1->SR1;						// clear the flag
	dummy = I2C1->SR2;
	//
	I2C1->CR1 |= I2C_CR1_ACK;					// ACK
	while ( (I2C1->SR1 & I2C_SR1_RXNE) == 0 );
	idFT201[ 0 ] = I2C1->DR;

	while ( (I2C1->SR1 & I2C_SR1_RXNE) == 0 );
	idFT201[ 1 ] = I2C1->DR;

	I2C1->CR1 &= ~I2C_CR1_ACK;					// NACK - ostatni
	while ( (I2C1->SR1 & I2C_SR1_RXNE) == 0 );
	idFT201[ 2 ] = I2C1->DR;
	//
	I2C1->CR1 |= I2C_CR1_STOP;					// wygeneruj stop
	while(I2C1->CR1 & I2C_CR1_STOP);			// czekaj na stop

	__NOP();
}


//------------------------------------------------------------
uint8_t ReadStatusFT201(){

	FT201status = ReadcmdFT201( 0x16 );

	return FT201status;
}


//------------------------------------------------------------
uint8_t  AvailableFT201(){
	return ReadcmdFT201( 0x0C );
}


//------------------------------------------------------------
void FlushFT201(){
	ReadcmdFT201( 0x0E );
}


//------------------------------------------------------------
uint8_t SetMtpAdrFT201( uint16_t adres ){
	uint32_t volatile dummy;
	UNUSED( dummy );


	__NOP();
	__HAL_I2C_ENABLE( &hi2c1 );	// I2C1->CR1 |= I2C_CR1_PE;		//  LL_I2C_Enable(I2C1);

	I2C1->CR1 |= I2C_CR1_START;      		//   I2C1_CR1_START_bb = 1;               // request a start
	while ( (I2C1->SR1 & I2C_SR1_SB) == 0 ); // while ( I2C1_SR1_SB_bb == 0);         // wait for start to finish
	dummy = I2C1->SR1;                  		// read of SR1 clears the flag
	//
	I2C1->DR = broadcastI2Cadr;						// transfer address
	while ( (I2C1->SR1 & I2C_SR1_ADDR) == 0);			// wait for address transfer
	dummy = I2C1->SR1;						// clear the flag
	dummy = I2C1->SR2;
	//
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0);		// wait for DR empty
	I2C1->DR = 0x10;					// trasnsfer byte
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0 || (I2C1->SR1 & I2C_SR1_BTF) == 1 );	// wait for bus not-busy
	//		I2C1->CR1 |= I2C_CR1_STOP;					// wygeneruj a stop
	//	   	while(I2C1->CR1 & I2C_CR1_STOP);			// czekaj na stop


	I2C1->CR1 |= I2C_CR1_START;      		//   I2C1_CR1_START_bb = 1;               // request a start
	while ( (I2C1->SR1 & I2C_SR1_SB) == 0 ); // while ( I2C1_SR1_SB_bb == 0);         // wait for start to finish
	dummy = I2C1->SR1;                  		// read of SR1 clears the flag
	//
	I2C1->DR = addressFT201;						// transfer address
	while ( (I2C1->SR1 & I2C_SR1_ADDR) == 0);			// wait for address transfer
	dummy = I2C1->SR1;						// clear the flag
	dummy = I2C1->SR2;
	//
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0);		// wait for DR empty
	I2C1->DR =  adres>>8;					// trasnsfer byte
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0 || (I2C1->SR1 & I2C_SR1_BTF) == 1 );	// wait for bus not-busy

	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0);		// wait for DR empty
	I2C1->DR =  adres;					// trasnsfer byte
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0 || (I2C1->SR1 & I2C_SR1_BTF) == 1 );	// wait for bus not-busy

	I2C1->CR1 |= I2C_CR1_STOP;					// wygeneruj a stop
	while(I2C1->CR1 & I2C_CR1_STOP);			// czekaj na stop
	__NOP();


	return( 0 );
}


//------------------------------------------------------------
uint16_t RdMtpFT201( uint16_t adres )
{

	if ( SetMtpAdrFT201( adres ) ) return UINT16_MAX;
	return ReadcmdFT201( 0x14 );
}


//------------------------------------------------------------
uint16_t ReadMtpFT201( uint16_t adres, uint16_t len, uint8_t *buf )
{
	uint16_t x;


	for(x=0; x<len; x++)
	{
		HAL_IWDG_Refresh(&hiwdg);

		*buf++ = RdMtpFT201( adres+x );	// *buf++ = d = ReadcmdFT201( adres+x );
		//if( d==UINT16_MAX ) return( x );
		__NOP();
	}

	return( x );
}


//------------------------------------------------------------
uint16_t WriteMtpFT201( uint16_t adres, uint8_t data )
{
	uint32_t volatile dummy;
	UNUSED( dummy );


	HAL_IWDG_Refresh(&hiwdg);


	if ( SetMtpAdrFT201( adres ) ) return UINT16_MAX;

	__NOP();
	__HAL_I2C_ENABLE( &hi2c1 );	// I2C1->CR1 |= I2C_CR1_PE;		//  LL_I2C_Enable(I2C1);

	I2C1->CR1 |= I2C_CR1_START;      		//   I2C1_CR1_START_bb = 1;               // request a start
	while ( (I2C1->SR1 & I2C_SR1_SB) == 0 ); // while ( I2C1_SR1_SB_bb == 0);         // wait for start to finish
	dummy = I2C1->SR1;                  		// read of SR1 clears the flag
	//
	I2C1->DR = broadcastI2Cadr;						// transfer address
	while ( (I2C1->SR1 & I2C_SR1_ADDR) == 0);			// wait for address transfer
	dummy = I2C1->SR1;						// clear the flag
	dummy = I2C1->SR2;
	//
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0);		// wait for DR empty
	I2C1->DR = 0x12;					// CMD
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0 || (I2C1->SR1 & I2C_SR1_BTF) == 1 );	// wait for bus not-busy
	//		I2C1->CR1 |= I2C_CR1_STOP;					// wygeneruj a stop
	//	   	while(I2C1->CR1 & I2C_CR1_STOP);			// czekaj na stop


	I2C1->CR1 |= I2C_CR1_START;      		//   I2C1_CR1_START_bb = 1;               // request a start
	while ( (I2C1->SR1 & I2C_SR1_SB) == 0 ); // while ( I2C1_SR1_SB_bb == 0);         // wait for start to finish
	dummy = I2C1->SR1;                  		// read of SR1 clears the flag
	//
	I2C1->DR = addressFT201;						// transfer address
	while ( (I2C1->SR1 & I2C_SR1_ADDR) == 0);			// wait for address transfer
	dummy = I2C1->SR1;						// clear the flag
	dummy = I2C1->SR2;
	//
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0);		// wait for DR empty
	I2C1->DR =  data;					// trasnsfer byte
	while ( (I2C1->SR1 & I2C_SR1_TXE) == 0 || (I2C1->SR1 & I2C_SR1_BTF) == 1 );	// wait for bus not-busy

	I2C1->CR1 |= I2C_CR1_STOP;					// wygeneruj a stop
	while(I2C1->CR1 & I2C_CR1_STOP);			// czekaj na stop
	__NOP();


	HAL_Delay( 10 );


	return( 0 );
}


//------------------------------------------------------------
uint16_t CalculateMtpCrc( uint16_t *buf )
{
uint16_t Checksum = 0xAAAA;				// Variable for checksum value
uint8_t fl15, AddressCounter = 0x00;   // Variable for address counter
uint16_t TempChecksum = 0x0000;    		// Used whilst calculating checksum
uint8_t CheckSumLocation = 0x7F;  		// Address at which checksum stored in FT-X


	// Starting at Word address 0x00
	AddressCounter = 0x00;

	// Calculation uses addresses from 0x00 up to 0x7E (checksum itself is located at 0x7F)
	while(AddressCounter < CheckSumLocation)
  		{
    	// EXOR the data with the current checksum and then rotate one bit to the left
		TempChecksum = *(buf+AddressCounter) ^ Checksum;
		//Checksum = (word)((TempChecksum << 1) | (TempChecksum >> 15));
		if (TempChecksum&0x8000) fl15=true; else fl15=false;
		TempChecksum <<= 1; if (fl15) TempChecksum |= 1;
		Checksum = TempChecksum;

    	// Go to next word address.
    	// If we have reached word address 0x12, then skip forward to address 0x40
    	AddressCounter ++;
    	if(AddressCounter == 0x12) AddressCounter = 0x40;
  	}


	return Checksum;
}


//======================================================================//
//------------------------------------------------------------


/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */


	//----- Zatrzymuj IWDG podczas debugowania -----//
	__HAL_DBGMCU_FREEZE_IWDG(); // DBGMCU -> APB1FZ |= DBGMCU_APB1_FZ_DBG_IWDG_STOP;

	//----- Nie rozlaczaj z debugerem po usypieniu, stop, itp
	DBGMCU->CR |= DBGMCU_CR_DBG_SLEEP | DBGMCU_CR_DBG_STOP | DBGMCU_CR_DBG_STANDBY;   //


	__HAL_DBGMCU_FREEZE_TIM1();
	__HAL_DBGMCU_FREEZE_TIM2();
	__HAL_DBGMCU_FREEZE_TIM3();
	__HAL_DBGMCU_FREEZE_TIM4();
	__HAL_DBGMCU_FREEZE_TIM5();
	__HAL_DBGMCU_FREEZE_TIM9();
	__HAL_DBGMCU_FREEZE_TIM10();
	__HAL_DBGMCU_FREEZE_TIM11();


  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */
	//
	//	MX_GPIO_Init();
	//	ReanimacjaI2C();
	//
  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_SPI1_Init();
  MX_TIM1_Init();
  MX_TIM2_Init();
  MX_IWDG_Init();
  MX_TIM3_Init();
  MX_DMA_Init();
  MX_USART2_UART_Init();
  MX_I2C1_Init();
  /* USER CODE BEGIN 2 */

	HAL_GPIO_WritePin(LED_R_GPIO_Port, LED_R_Pin, GPIO_PIN_SET);


	LedInit();
	PrintStringLED( STOPKA1 );


	ssd1306_init( true );
	/*
	ssd1306_clearDisplay();
	ssd1306_SetFont( 0x0507 );
	ssd1306_PrintString( 0, 0, "Test", 1 );
	ssd1306_SetFont( 0x1616 );
	ssd1306_PrintString( 0, 8, "Test", 1 );
	ssd1306_SetFont( 0x1632 );
	ssd1306_PrintString( 0, 8+16, "Test", 1 );
	ssd1306_display( true );
	 */


	//----- Pomiar czasu przez timer 1 -----//
	//  __HAL_TIM_ENABLE_IT(&htim1, TIM_IT_UPDATE | TIM_IT_CC1 | TIM_IT_CC2 );    // Przerwania
	//  __HAL_TIM_ENABLE_IT(&htim1, TIM_IT_UPDATE );    // Przerwania
	HAL_TIM_Base_Start_IT(&htim1);               // Start timera z IRQ
	TIM1->ARR = UINT16_MAX;
	TIM1->PSC = 0;
	TIM1->CCMR1 = TIM_CCMR1_CC1S_0 | TIM_CCMR1_CC2S_1;
	TIM1->CCER = TIM_CCER_CC2P | TIM_CCER_CC1E | TIM_CCER_CC2E;
	TIM1->SMCR = TIM_SMCR_TS_2 | TIM_SMCR_TS_0 | TIM_SMCR_SMS_2;
	TIM1->CR1 = TIM_CR1_CEN;
	//__HAL_TIM_ENABLE_IT(&htim1, TIM_IT_UPDATE );	//Przerwania od przepełnienia


	//----- Pomiar czestotliwosci przez Timer2 bramkowany Timerem 3 -----//
	__HAL_TIM_ENABLE_IT(&htim2, TIM_IT_UPDATE);   // Przerwania od przepelnienia
	HAL_TIM_Base_Start_IT(&htim2);                // Start timera
	__HAL_TIM_ENABLE_IT(&htim2, TIM_IT_TRIGGER ); 	// przerwania
	setGate( TIM_DEF_GATE );
	//
	HAL_TIM_Base_Start_IT(&htim3);                // Start timera 3
	HAL_TIM_PWM_Start(&htim3, TIM_CHANNEL_1);
	__HAL_TIM_ENABLE_IT(&htim3, TIM_IT_UPDATE ); 	// przerwania od przepełnienia


  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */


	uint8_t static cntFT201;
	ReadMtpFT201( 0x18 << 1, 1, &cntFT201 );		// W FT_PROG widzimy słowa więc adres 0x18 w FT_PROG jest faktycznie adresem 2 razy większym
	cntFT201++;
	WriteMtpFT201( 0x18 << 1, cntFT201 );
	__NOP();
	/*
	{
		char txt[] = "sas@elportal.pl";
		uint8_t adr = 0x20 << 1;
		for(uint16_t x=0; x<strlen(txt); x+=2){
			WriteMtpFT201( adr++, txt[ x+1 ] );
			WriteMtpFT201( adr++, txt[ x+0 ] );
			__NOP();
		}
	}
	*/
	__NOP();


	// LOOP:
	while (1)
	{
		HAL_IWDG_Refresh(&hiwdg);
		__WFI();


		if( !timLedRun ){
			timLedRun = 500;

			HAL_GPIO_TogglePin(LED_B_GPIO_Port, LED_B_Pin);


			ReadStatusFT201();
			ReadIdFT201();


			ReadMtpFT201( 0, 256, mtpFT201 );
			uint16_t static volatile crcFT201;
			crcFT201 = CalculateMtpCrc( (uint16_t*)mtpFT201 );
			// starszy pod adresem 255
			// młodszy 254
			if( (crcFT201 & 255) != mtpFT201[ 254 ] || (crcFT201 >> 8) != mtpFT201[ 255 ] ){
				// Zła CRC
				__NOP();
			}
			__NOP();
		}



		if( ! timSendUsb ){
			timSendUsb = 2000;

			char static txt[100];
			uint16_t static cnt;
			uint8_t static volatile st;
			sprintf( txt, "Ramka %d\n\r", ++cnt );
			__NOP();

			st = HAL_I2C_Master_Transmit(&hi2c1, 0x44, (uint8_t *)txt, strlen(txt), 1 );
			if( st != HAL_OK ){
				__NOP();
			}
		}



		uint8_t static FT201rxLen;
		{
			/*
			__NOP();
			__HAL_I2C_ENABLE( &hi2c1 );	// I2C1->CR1 |= I2C_CR1_PE;		//  LL_I2C_Enable(I2C1);
			uint8_t cmd = 0x0C;
			uint32_t volatile dummy;
			UNUSED( dummy );

			I2C1->CR1 |= I2C_CR1_START;      		//   I2C1_CR1_START_bb = 1;               // request a start
			while ( (I2C1->SR1 & I2C_SR1_SB) == 0 ); // while ( I2C1_SR1_SB_bb == 0);         // wait for start to finish
			dummy = I2C1->SR1;                  		// read of SR1 clears the flag
			//
			I2C1->DR = broadcastI2Cadr;						// transfer address
			while ( (I2C1->SR1 & I2C_SR1_ADDR) == 0);			// wait for address transfer
			dummy = I2C1->SR1;						// clear the flag
			dummy = I2C1->SR2;
			//
			while ( (I2C1->SR1 & I2C_SR1_TXE) == 0);		// wait for DR empty
			I2C1->DR = cmd;					// trasnsfer byte
			//
			while ( (I2C1->SR1 & I2C_SR1_TXE) == 0 || (I2C1->SR1 & I2C_SR1_BTF) == 1 );	// wait for bus not-busy
			//		I2C1->CR1 |= I2C_CR1_STOP;					// wygeneruj stop
			//	   	while(I2C1->CR1 & I2C_CR1_STOP);			// czekaj na stop


			I2C1->CR1 |= I2C_CR1_START;      		//   I2C1_CR1_START_bb = 1;               // request a start
			while ( (I2C1->SR1 & I2C_SR1_SB) == 0 ); // while ( I2C1_SR1_SB_bb == 0);         // wait for start to finish
			dummy = I2C1->SR1;                  		// read of SR1 clears the flag
			//
			I2C1->DR = addressFT201 | 1;						// transfer address
			while ( (I2C1->SR1 & I2C_SR1_ADDR) == 0);			// wait for address transfer
			dummy = I2C1->SR1;						// clear the flag
			dummy = I2C1->SR2;
			//
			I2C1->CR1 &= ~I2C_CR1_ACK;					// NACK - ostatni (w tym przypadku jedyny) bajt do odczytu
			while ( (I2C1->SR1 & I2C_SR1_RXNE) == 0 );
			FT201rxLen = I2C1->DR;
			//
			I2C1->CR1 |= I2C_CR1_STOP;					// wygeneruj stop
			while(I2C1->CR1 & I2C_CR1_STOP);			// czekaj na stop

			//			__HAL_I2C_DISABLE( &hi2c1 );
			__NOP();
			*/
			FT201rxLen = AvailableFT201();
		}



		uint8_t static FT201rxNew, bufRxFT201[256];
		if( FT201rxLen ){
			__NOP();
			//uint8_t d;
			//while( HAL_I2C_Master_Receive(&hi2c1, 0x44, &d, 1, 1 ) == HAL_OK ){
			//	if( FT201rxLen < 255 ) bufRxFT201[ FT201rxLen++ ] = d;
			//	FT201rxNew++;
			//	__NOP();
			//}
			HAL_I2C_Master_Receive(&hi2c1, 0x44, bufRxFT201, FT201rxLen, 2 ); FT201rxNew += FT201rxLen;
			__NOP();
			//uint8_t static prevNew;
			//if( prevNew != FT201rxNew ){
			//	prevNew = FT201rxNew;

			char static txt[300];
			bufRxFT201[ FT201rxLen ] = 0;
			sprintf( txt, ANSI_PEN_GREEN"RX: "ANSI_PEN_YELLOW"%s\n\r"ANSI_PEN_WHITE, bufRxFT201 );
			HAL_I2C_Master_Transmit(&hi2c1, 0x44, (uint8_t *)txt, strlen(txt), 1 );

			FT201rxLen = 0;
			//}
			__NOP();
		}




		if( ! timMax7219 ){
			timMax7219 = 80;

			/*
			uint8_t static volatile x, s;
			uint16_t static volatile d;
			d = x >> 3;
			d++;
			d <<= 8;
			s = 1 << (x & 7);

			for(uint8_t x=0; x<LICZBA_MAX7219; x++ )	bufMAX7219[ x ] =  d | s;
			MAX7219_send_X( bufMAX7219, LICZBA_MAX7219 );
			 */

			int16_t static x;
			uint8_t static d=20, intensywnosc = 8;;

			MAX7219_Clr();
			char static txt[50];
			sprintf( txt, "Jasno"_s_""_c_" %d", intensywnosc );
			MAX72196_PrintString( x, 0, txt, 1 );
			MAX7219_send_scr();

			{
				uint8_t static dir=0;
				if( dir ){
					if( ++x >= MAX7219_SZER ) dir = false;
				}
				else{
					if( --x < -50 ) dir = true;
				}
			}

			//if( ++x >= 64 ) x=0;
			TRAP;


			if (--d == 0 ){
				d = 3;
				uint8_t static dir=0;

				if( dir ){
					if( ++intensywnosc >= 15 ) dir=false;
				}
				else{
					if( --intensywnosc == 0 ) dir=true;
				}
				MAX7219_intensity( intensywnosc );
			}
		}


		uint8_t static prt, prevKey;
		if( prevKey != KeyUSER ){		// Zmiana stanu przycisku ?
			prevKey = KeyUSER;
			if( KeyUSER ){				// Aktywny ?
				if( ++prt > 9 ) prt = 0;
			}
		}


		float static tL, tH, okres, fx, duty, OkresX;
		if( ! timPrintLed ){
			timPrintLed = 100;


			ReadSetFtime();


			char static txt[50];
#define	TIM_INPUT		15000
			//----- Wykrywanie braku sygnału -----//
			//uint8_t static prevGpio;
			//if( prevGpio != HAL_GPIO_ReadPin( GPIOA, GPIO_PIN_8 ) ){
			//	  prevGpio = HAL_GPIO_ReadPin( GPIOA, GPIO_PIN_8);
			//	  timInput = TIM_INPUT;
			if( TIM1->SR & TIM_IT_TRIGGER ) {		// Czy flaga wyzwolenia ustawiona ?
				TIM1->SR &= ~TIM_IT_TRIGGER;		// Kasuj flagę

				timInput = TIM_INPUT;				// Ustaw timeout
			}


			//if( TIM1-> ){
			if( ! timInput ){
				T1Okres = T1PulsH = 0;
				TRAP;
			}



			tH = 1e6 * T1PulsH / F_CPU;    // Czas L w us
			tL = 1e6 * (T1Okres - T1PulsH) / F_CPU; // Czas H w us
			okres = 1e6 * T1Okres / F_CPU;  // Okres w us
			if( okres != 0 ){
				fx = 1.0 / (okres / 1e6);
				duty = tH * 100 / okres;
			}
			else{
				fx = duty = 0;
			}
			if( Freq != 0 ){
				OkresX = 1.0 / (float)Freq;
				OkresX *= 1000000;
			}
			else OkresX = 0;



			if( !timDemo ){
				ssd1306_clearDisplay();
				uint8_t dot = 0;
				uint8_t pozX;
				//
				switch( prt ){
				case 0:
					if( Freq >= GRANICA_F ){
						pozX = PrintFreqIntLED( Freq, "" );
						ssd1306_SetFont( 0x0705 );
						ssd1306_PrintString( pozX, 0, "(cnt)", 1 );
						PrintGateTFT( pozX, 8 );
					}
					else{
						pozX = PrintFreqFloatLED( fx, "");
						ssd1306_SetFont( 0x0705 );
						ssd1306_PrintString( pozX, 0, "(match)", 1 );
					}
					//
					//----- Drugi wskaźnik
					ssd1306_SetFont( 0x0705 );
					PrintTimeTFT( "tH ", 0, 32, tH );
					PrintTimeTFT( "tL ", 0, 32+8, tL );
					PrintTimeTFT( "period %", 0, 32+16, okres );
					sprintf( txt, "duty  %% %0.2f", duty ); ssd1306_PrintString( 0, 32+24, txt, 1 );
					break;
				case 1:
					if( Freq < GRANICA_F ){
						pozX = PrintTimeFloatLED( okres, "period" );
						ssd1306_SetFont( 0x0705 );
						ssd1306_PrintString( pozX, 0, "(cnt)", 1 );
						PrintGateTFT( pozX, 8 );
					}
					else{
						pozX = PrintTimeFloatLED( OkresX, "period" );
						ssd1306_SetFont( 0x0705 );
						ssd1306_PrintString( pozX, 0, "(match)", 1 );
						PrintGateTFT( pozX, 8 );
					}
					//
					//----- Drugi wskaźnik
					PrintFreqTFT( 0, 32+8, Freq, fx );
					break;
				case 2:
					PrintTimeFloatLED( tH, "High" );
					//
					//----- Drugi wskaźnik
					PrintFreqTFT( 0, 32+8, Freq, fx );
					break;
				case 3:
					PrintTimeFloatLED( tL, "Low" );
					//
					//----- Drugi wskaźnik
					PrintFreqTFT( 0, 32+8, Freq, fx );
					break;
				case 4:
					sprintf( txt, "%8.2f", duty );
					dot = convStrDot( txt );
					PrintStringDotLED( txt, dot );
					PrintJednostki_TFT( "% duty" );
					//
					//----- Drugi wskaźnik
					PrintFreqTFT( 0, 32+8, Freq, fx );
					break;
				case 5:
					pozX = PrintCntIntLED( TIM2->CNT, "" );
					ssd1306_SetFont( 0x0705 );
					pozX -= 8;
					sprintf( txt, "F %d.%03d kHz", (int)(Freq / 1000), (int)(Freq % 1000) ); ssd1306_PrintString( pozX, 0, txt, 1 );
					sprintf( txt, "%0.6f kHz", fx / 1000 ); ssd1306_PrintString( pozX, 8, txt, 1 );
					sprintf( txt, "Latch %d", (int)cntlatch ); ssd1306_PrintString( pozX, 24, txt, 1 );
					//
					//----- Drugi wskaźnik
					ssd1306_SetFont( 0x0705 );
					PrintTimeTFT( "tH ", 0, 32, tH );
					PrintTimeTFT( "tL ", 0, 32+8, tL );
					PrintTimeTFT( "period %", 0, 32+16, okres );
					sprintf( txt, "duty  %% %0.2f", duty ); ssd1306_PrintString( 0, 32+24, txt, 1 );
					break;
				case 6:
					pozX = PrintFreqIntLED( Freq, "" );
					ssd1306_SetFont( 0x0705 );
					ssd1306_PrintString( pozX, 0, "(cnt)", 1 );
					PrintGateTFT( pozX, 8 );
					break;
				case 7:
					PrintFreqFloatLED( fx, "");
					ssd1306_SetFont( 0x0705 );
					ssd1306_PrintString( pozX, 0, "(match)", 1 );
					break;
				case 8:
					PrintTimeFloatLED( okres, "" );
					ssd1306_SetFont( 0x0705 );
					ssd1306_PrintString( pozX, 0, "(cnt)", 1 );
					break;
				case 9:
					PrintTimeFloatLED( OkresX, "" );
					ssd1306_SetFont( 0x0705 );
					ssd1306_PrintString( pozX, 0, "(match)", 1 );
					PrintGateTFT( pozX, 8 );
					TRAP;
					break;
				}
				ssd1306_display( true );
			}
		}


		//----- UART -----//
		if( ! timUart ){
			timUart = 2000;

			uint32_t static cnt;
			char static txt[500];
			sprintf( txt, ANSI_CLS"Freq = %d Hz"CRLF"fx = %f Hz"CRLF"period = %f us"CRLF"PeriodX = %f us"CRLF"tH = %f us"CRLF"tL = %f us"CRLF"duty = %f %%"CRLF"cnt = %d imp"CRLF"Latch = %d imp"CRLF"chgIn = %d, tim2_gate_H=%d"CRLF"%d mnoznikT=%d"CRLF,
					(int)Freq, fx, okres, OkresX, tH, tL, duty, (int)(TIM2->CNT), (int)cntlatch, cntChangeInput, (int)tim2_gate_H, (int)++cnt, mnoznikT );
			HAL_UART_Transmit_DMA(&huart2, (uint8_t*)txt, strlen(txt) );
		}


    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
	}
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage 
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_LSI|RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.LSIState = RCC_LSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 4;
  RCC_OscInitStruct.PLL.PLLN = 100;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 8;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_3) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief I2C1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_I2C1_Init(void)
{

  /* USER CODE BEGIN I2C1_Init 0 */

  /* USER CODE END I2C1_Init 0 */

  /* USER CODE BEGIN I2C1_Init 1 */

  /* USER CODE END I2C1_Init 1 */
  hi2c1.Instance = I2C1;
  hi2c1.Init.ClockSpeed = 400000;
  hi2c1.Init.DutyCycle = I2C_DUTYCYCLE_2;
  hi2c1.Init.OwnAddress1 = 0;
  hi2c1.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c1.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
  hi2c1.Init.OwnAddress2 = 0;
  hi2c1.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
  hi2c1.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
  if (HAL_I2C_Init(&hi2c1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN I2C1_Init 2 */

  /* USER CODE END I2C1_Init 2 */

}

/**
  * @brief IWDG Initialization Function
  * @param None
  * @retval None
  */
static void MX_IWDG_Init(void)
{

  /* USER CODE BEGIN IWDG_Init 0 */

  /* USER CODE END IWDG_Init 0 */

  /* USER CODE BEGIN IWDG_Init 1 */

  /* USER CODE END IWDG_Init 1 */
  hiwdg.Instance = IWDG;
  hiwdg.Init.Prescaler = IWDG_PRESCALER_16;
  hiwdg.Init.Reload = 4095;
  if (HAL_IWDG_Init(&hiwdg) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN IWDG_Init 2 */

  /* USER CODE END IWDG_Init 2 */

}

/**
  * @brief SPI1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SPI1_Init(void)
{

  /* USER CODE BEGIN SPI1_Init 0 */

  /* USER CODE END SPI1_Init 0 */

  /* USER CODE BEGIN SPI1_Init 1 */

  /* USER CODE END SPI1_Init 1 */
  /* SPI1 parameter configuration*/
  hspi1.Instance = SPI1;
  hspi1.Init.Mode = SPI_MODE_MASTER;
  hspi1.Init.Direction = SPI_DIRECTION_2LINES;
  hspi1.Init.DataSize = SPI_DATASIZE_16BIT;
  hspi1.Init.CLKPolarity = SPI_POLARITY_LOW;
  hspi1.Init.CLKPhase = SPI_PHASE_1EDGE;
  hspi1.Init.NSS = SPI_NSS_SOFT;
  hspi1.Init.BaudRatePrescaler = SPI_BAUDRATEPRESCALER_256;
  hspi1.Init.FirstBit = SPI_FIRSTBIT_MSB;
  hspi1.Init.TIMode = SPI_TIMODE_DISABLE;
  hspi1.Init.CRCCalculation = SPI_CRCCALCULATION_DISABLE;
  hspi1.Init.CRCPolynomial = 10;
  if (HAL_SPI_Init(&hspi1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SPI1_Init 2 */

  /* USER CODE END SPI1_Init 2 */

}

/**
  * @brief TIM1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM1_Init(void)
{

  /* USER CODE BEGIN TIM1_Init 0 */

  /* USER CODE END TIM1_Init 0 */

  TIM_ClockConfigTypeDef sClockSourceConfig = {0};
  TIM_SlaveConfigTypeDef sSlaveConfig = {0};
  TIM_MasterConfigTypeDef sMasterConfig = {0};

  /* USER CODE BEGIN TIM1_Init 1 */

  /* USER CODE END TIM1_Init 1 */
  htim1.Instance = TIM1;
  htim1.Init.Prescaler = 0;
  htim1.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim1.Init.Period = 0;
  htim1.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim1.Init.RepetitionCounter = 0;
  htim1.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_DISABLE;
  if (HAL_TIM_Base_Init(&htim1) != HAL_OK)
  {
    Error_Handler();
  }
  sClockSourceConfig.ClockSource = TIM_CLOCKSOURCE_INTERNAL;
  if (HAL_TIM_ConfigClockSource(&htim1, &sClockSourceConfig) != HAL_OK)
  {
    Error_Handler();
  }
  sSlaveConfig.SlaveMode = TIM_SLAVEMODE_DISABLE;
  sSlaveConfig.InputTrigger = TIM_TS_TI1F_ED;
  sSlaveConfig.TriggerFilter = 0;
  if (HAL_TIM_SlaveConfigSynchro(&htim1, &sSlaveConfig) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim1, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM1_Init 2 */

  /* USER CODE END TIM1_Init 2 */

}

/**
  * @brief TIM2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM2_Init(void)
{

  /* USER CODE BEGIN TIM2_Init 0 */

  /* USER CODE END TIM2_Init 0 */

  TIM_ClockConfigTypeDef sClockSourceConfig = {0};
  TIM_SlaveConfigTypeDef sSlaveConfig = {0};
  TIM_MasterConfigTypeDef sMasterConfig = {0};

  /* USER CODE BEGIN TIM2_Init 1 */

  /* USER CODE END TIM2_Init 1 */
  htim2.Instance = TIM2;
  htim2.Init.Prescaler = 0;
  htim2.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim2.Init.Period = 0xffffffff;
  htim2.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim2.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_ENABLE;
  if (HAL_TIM_Base_Init(&htim2) != HAL_OK)
  {
    Error_Handler();
  }
  sClockSourceConfig.ClockSource = TIM_CLOCKSOURCE_ETRMODE2;
  sClockSourceConfig.ClockPolarity = TIM_CLOCKPOLARITY_NONINVERTED;
  sClockSourceConfig.ClockPrescaler = TIM_CLOCKPRESCALER_DIV1;
  sClockSourceConfig.ClockFilter = 0;
  if (HAL_TIM_ConfigClockSource(&htim2, &sClockSourceConfig) != HAL_OK)
  {
    Error_Handler();
  }
  sSlaveConfig.SlaveMode = TIM_SLAVEMODE_GATED;
  sSlaveConfig.InputTrigger = TIM_TS_TI2FP2;
  sSlaveConfig.TriggerPolarity = TIM_TRIGGERPOLARITY_RISING;
  sSlaveConfig.TriggerFilter = 0;
  if (HAL_TIM_SlaveConfigSynchro(&htim2, &sSlaveConfig) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim2, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM2_Init 2 */

  /* USER CODE END TIM2_Init 2 */

}

/**
  * @brief TIM3 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM3_Init(void)
{

  /* USER CODE BEGIN TIM3_Init 0 */

  /* USER CODE END TIM3_Init 0 */

  TIM_ClockConfigTypeDef sClockSourceConfig = {0};
  TIM_MasterConfigTypeDef sMasterConfig = {0};
  TIM_OC_InitTypeDef sConfigOC = {0};

  /* USER CODE BEGIN TIM3_Init 1 */

  /* USER CODE END TIM3_Init 1 */
  htim3.Instance = TIM3;
  htim3.Init.Prescaler = 49999;
  htim3.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim3.Init.Period = 999;
  htim3.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim3.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_ENABLE;
  if (HAL_TIM_Base_Init(&htim3) != HAL_OK)
  {
    Error_Handler();
  }
  sClockSourceConfig.ClockSource = TIM_CLOCKSOURCE_INTERNAL;
  if (HAL_TIM_ConfigClockSource(&htim3, &sClockSourceConfig) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_TIM_PWM_Init(&htim3) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_ENABLE;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim3, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  sConfigOC.OCMode = TIM_OCMODE_PWM1;
  sConfigOC.Pulse = 499;
  sConfigOC.OCPolarity = TIM_OCPOLARITY_HIGH;
  sConfigOC.OCFastMode = TIM_OCFAST_DISABLE;
  if (HAL_TIM_PWM_ConfigChannel(&htim3, &sConfigOC, TIM_CHANNEL_1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM3_Init 2 */

  /* USER CODE END TIM3_Init 2 */
  HAL_TIM_MspPostInit(&htim3);

}

/**
  * @brief USART2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART2_UART_Init(void)
{

  /* USER CODE BEGIN USART2_Init 0 */

  /* USER CODE END USART2_Init 0 */

  /* USER CODE BEGIN USART2_Init 1 */

  /* USER CODE END USART2_Init 1 */
  huart2.Instance = USART2;
  huart2.Init.BaudRate = 921600;
  huart2.Init.WordLength = UART_WORDLENGTH_8B;
  huart2.Init.StopBits = UART_STOPBITS_1;
  huart2.Init.Parity = UART_PARITY_NONE;
  huart2.Init.Mode = UART_MODE_TX_RX;
  huart2.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart2.Init.OverSampling = UART_OVERSAMPLING_16;
  if (HAL_UART_Init(&huart2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART2_Init 2 */

  /* USER CODE END USART2_Init 2 */

}

/** 
  * Enable DMA controller clock
  */
static void MX_DMA_Init(void) 
{

  /* DMA controller clock enable */
  __HAL_RCC_DMA1_CLK_ENABLE();
  __HAL_RCC_DMA2_CLK_ENABLE();

  /* DMA interrupt init */
  /* DMA1_Stream1_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Stream1_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA1_Stream1_IRQn);
  /* DMA1_Stream6_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Stream6_IRQn, 4, 0);
  HAL_NVIC_EnableIRQ(DMA1_Stream6_IRQn);
  /* DMA2_Stream2_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA2_Stream2_IRQn, 4, 0);
  HAL_NVIC_EnableIRQ(DMA2_Stream2_IRQn);

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOH_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(LED_SS_GPIO_Port, LED_SS_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOB, LED_B_Pin|LED_G_Pin, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOB, LED_R_Pin|GATE_OUT_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin : LED_SS_Pin */
  GPIO_InitStruct.Pin = LED_SS_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  HAL_GPIO_Init(LED_SS_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin : PB_USER_Pin */
  GPIO_InitStruct.Pin = PB_USER_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  HAL_GPIO_Init(PB_USER_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pins : LED_B_Pin LED_R_Pin LED_G_Pin GATE_OUT_Pin */
  GPIO_InitStruct.Pin = LED_B_Pin|LED_R_Pin|LED_G_Pin|GATE_OUT_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
	/* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
	/* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
